/* GCC */
#include <bits/stdc++.h>

using namespace std;
struct longnum {
    int len, num[1001];
};
void input_arr( unsigned long long arr[], int n){
    for( int i = 1; i <= n; i++) cin>> arr[i];
}
void output_arr( unsigned long long arr[], int n){
    for( int i = 1; i < n; i++) cout<< arr[i]<< " ";
    cout<< arr[n]<< '\n';
}
void input_long( longnum &a){
    string s;
    cin>> s;
    a.len = s.size();
    for ( int i = 0; i < a.len; i++) a.num[1000-a.len+i]= int(s[i])-48;
}
void output_long( longnum a){
    for ( int i = 1000 - a.len; i < 1000; i++) cout<< a.num[i];
    cout<< '\n';
}
void shiftr( unsigned long long arr[], int n){
    for( int i = n; i > 0; i--){
        arr[i] = arr[i-1];
    }
}
void shiftl( int arr[], int left, int right, int k){
    for ( int i = 0; i < k; i++){
        for( int i = left; i < right-1; i++){
            arr[i]= arr[i+1];
        }
        arr[right-1]= 0;
    }
}
void len_long ( longnum &a){
    a.num[1000]=1;
    int i = 0;
    while( a.num[i]==0 ) i++;
    if( i!= 1000) a.len = 1000-i;
    else a.len = 1;
}
void plus_long(longnum a, longnum b, longnum &ans){
    int p = 0;
    for(int i = 999; i >= 0; i--){
        int sum = 0;
        sum = a.num[i] + b.num[i] + p;
        ans.num[i] = sum % 10;
        p = sum / 10;
    }
    len_long(ans);
}
void multy( longnum a, int b, longnum &ans){
    int p = 0;
    for ( int i = 999; i >= 0; i--){
        int sum;
        sum = b * a.num[i] + p;
        ans.num[i] = sum % 10;
        p = sum / 10;
    }
    len_long(ans);
}
void multy_long( longnum a, longnum b, longnum &ans){
    int k = 0;
    for ( int i = 999; i >= 1000 - b.len; i-- ){
        longnum temp = {0};
        multy(a, b.num[i], temp);
        shiftl(temp.num, 1000-temp.len, 1000, k);
        temp.len+= k;
        k++;
        plus_long(ans, temp, ans);
        //len_long(ans);
    }
}
int main()
{
    freopen("cucumbers.in", "r", stdin);
    freopen("cucumbers.out", "w", stdout);
    unsigned long long year, temp[12], sp_step[11], box[11]={0};
    int life;
    for( int i = 0; i < 12; i++){
        temp[i]=0;
        sp_step[i]=0;
    }
    cin>> year>> life;
    input_arr(sp_step, life);
    input_arr(box, life);

    temp[0]=1;
    for( unsigned long long i = 0; i < year; i++){
        unsigned long long sp = 0;
        shiftr(temp, life);
        for( int i = 1; i <= life; i++) {
            sp+= sp_step[i]*temp[i];
        }
        temp[0]=sp;
    }
    for ( int i = 1; i <= life; i++) temp[i]%= box[i];
    output_arr(temp, life);
    return 0;
}
