/* GCC */
#include <bits/stdc++.h>

using namespace std;
struct point {
    int x, y;
};
void outputcord( point cord[], int n ){
    for( int i = 0; i < n; i++){
        cout<< cord[i].x<< " "<< cord[i].y<< "\n";
    }
}
bool comp( point a, point b){
    return ( a.x < b.x);
}
double len(point a, point b){
    return sqrt( (a.x - b.x)*(a.x - b.x) + (a.y - b.y)*(a.y - b.y));
}
double square( point a, point b, point c){
    double as, bs, cs;
    as = len(c,b);
    bs = len(a, c);
    cs = len(a, b);
    double p = as + bs + cs;
    p /= 2;
    return sqrt( p*(p - as)*(p - bs)*(p - cs));
}
double per( point a, point b, point x){
    return 2.0*square(a, b, x)/len(a,b);
}
double max_per(point cord[], int n, point a, point b){
    double perp= -1;
    for( int i = 0; i < n ; i++){
        perp = max(perp, per(a, b, cord[i]));
    }
    return perp;
}

int main()
{
    freopen("triangle.in", "r", stdin);
    freopen("triangle.out", "w", stdout);
    int n;
    point cord[2020]={0};
    double s = 0;
    cin>> n;
    for( int i = 0; i < n; i++) cin>> cord[i].x>> cord[i].y;
    sort( cord, cord+n, comp);
    for(int i = 0; i < n - 1; i++){
        point be = cord[i], en = cord[i+1];
        s = max( s,0.5*len(be, en)*max_per(cord, n, be, en));
    }
    cout<< s<< '\n';

    return 0;
}
