/* GCC */
#include <iostream>
#include <fstream>
#include <math.h>
#include <vector>
#include <stdlib.h>

using namespace std;

struct Point{
    int x;
    int y;
};

int main()
{
    ifstream fin;
    fin.open("triangle.in");
    int n;
    fin >> n;
    vector<Point> v(n);
    vector<double> d(n);
    vector<vector<double> > dists(n, d);
    for (int i = 0; i < n; i++){
        fin >> v[i].x >> v[i].y;
    }
    fin.close();
    int max_s = 0;
    for (int i = 0; i < n; i++){
        for (int j = i+1; j < n; j++){
            for (int k = j+1; k < n; k++){
                int x1 = v[j].x - v[i].x, y1 = v[j].y - v[i].y;
                int x2 = v[k].x - v[i].x, y2 = v[k].y - v[i].y;
                int S = abs(x1*y2-x2*y1);
                max_s = max(S, max_s);
            }
        }
    }
    ofstream fout;
    fout.open("triangle.out");
    if (max_s % 2 == 0){
        fout << max_s/2 << endl;
    } else {
        fout << max_s/2 << ".5" << endl;
    }
    fout.close();
    return 0;
}









