/* GCC */
#include <bits/stdc++.h>

using namespace std;

int LCD(int a, int b){
    if(b > a)
        swap(a, b);
    while(b){
        a%=b;
        swap(a, b);
    }
    return a;
}

int main()
{
    freopen("cucumbers.in", "r", stdin);
    freopen("cucumbers.out", "w", stdout);
    unsigned long long N, M;
    cin >> M >> N;
    vector<unsigned long long> vec(N);
    vector<unsigned long long> uec(N);
    vector<unsigned long long> wec(N);
    for(int i = 0; i < N; i++)
        cin >> uec[i];
    cin >> wec[0];
    int lcd = wec[0], mod = wec[0];
    for(int i = 1; i < N; i++){
        cin >> wec[i];
        lcd = LCD(lcd, wec[i]);
        mod *= wec[i];
    }
    mod /= lcd;
    int spores = 1;
    for(int j = 0; j < M; j++){
        for(int i = N - 2; i >= 0; i--)
            vec[i + 1] = vec[i]%mod;
        vec[0] = spores;
        spores = 0;
        for(int i = 0; i < N; i++)
            spores = (spores%mod + (vec[i]*uec[i])%mod)%mod;
    }
    for(int i = 0; i < N - 1; i++)
        cout << vec[i]%wec[i] << ' ';
    cout << (vec[N - 1]%wec[N - 1]) << '\n';
    return 0;
}
