/* GCC */
#include <bits/stdc++.h>

using namespace std;

struct place{
    vector<int> streets;
    bool isbus = 0;
};

int bfs(int start, vector<place> &vec){
    queue<int> q;
    vector<int> time(vec.size());
    q.push(start);
    while(1){
        int qf = q.front();
        for(int i = 0; i < vec[qf].streets.size(); i++){
            if(!time[vec[qf].streets[i]] && vec[qf].streets[i] != start){
                if(vec[vec[qf].streets[i]].isbus == 1){
                    return time[qf] + 1;
                }
                else{
                    q.push(vec[qf].streets[i]);
                    time[vec[qf].streets[i]] = time[qf] + 1;
                }
            }
        }
        q.pop();
    }
}




int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    freopen("hiking.in", "r", stdin);
    freopen("hiking.out", "w", stdout);
    int N, M, K;
    cin >> N >> M >> K;
    vector<place> vec(N);
    for(int i = 0, temp1, temp2; i < M; i++){
        cin >> temp1 >> temp2;
        vec[temp1 - 1].streets.push_back(temp2 - 1);
        vec[temp2 - 1].streets.push_back(temp1 - 1);
    }
    for(int i = 0, temp; i < K; i++){
        cin >> temp;
        vec[temp - 1].isbus = 1;
    }
    int ans = 1000000000;
    for(int i = 0; i < N; i++){
        if(vec[i].isbus)
            ans = min(ans, bfs(i, vec));
    }
    cout << ans << '\n';
}
