/* GCC */
#include <iostream>

using namespace std;
const int nmax = 1000;

void string_to_int(string s, long long a[])
{
    for(int  i = 0 ; i < s.size() ; i ++ )
    {
        a[nmax - i] = s[s.size() - 1 - i] - 48;
    }
    a[0] = s.size();
}

void int_to_string(long long a[], string & s)
{
    s = "";
    for(int i = nmax - a[0] + 1 ; i <= nmax ; i++)
        s += char(a[i] +48);
}


void mas_in(long long n, long long mas[])
{
    for(int i = 0 ; i < n; i ++)
        cin >> mas[i];
}
int len_long(long long a[])
{
    a[nmax + 1] = 13;
    int i = 1;
    while(a[i] == 0)
        i++;
    return nmax - i + 1 + (i > nmax);
}

string sum_long(string sa, string  sb)
{
    long long a[nmax + 2] = {0};
    long long b[nmax + 2] = {0};
    long long res[nmax + 2] = {0};
    string_to_int(sa, a);
    string_to_int(sb, b);
    int s, p = 0;
    for(int i = 0 ; i <= max(sa.size(), sb.size()) + 1 ; i ++)
    {
        s = a[nmax - i] + b[nmax - i] + p;
        p = s/10;
        res[nmax - i] = s % 10;
    }
    res[0] = len_long(res);
    string sres;
    int_to_string(res,sres);
    return sres;
}

string half_long_mult(string sa, long long b)
{
    long long a[nmax + 2] = {0}, p = 0;
    long long s;
    string_to_int(sa,a);
    long long res[nmax + 2] = {0};
    for(int i = 0 ; i <= sa.size() + 1 ; i ++)
    {
        s = a[nmax - i] * b  + p;
        p= s/10;
        res[nmax - i] = s%10;
    }
    res[0] = len_long(res);
    string sres;
    int_to_string(res,sres);
    return sres;
}

void growth(string plants[], long long spears[], long long n)
{
    plants[0] = "0";
    for(int j = 1; j <= n ; j ++)
        plants[0] = sum_long(plants[0], half_long_mult(plants[j], spears[j - 1]) );
    for(int j = n ; j > 0 ; j --)
        plants[j] = plants[j - 1];
}
/*void growth( int plants[], int spears[], int n)
{
    plants[0] = 0;
    for(int i = 1 ; i <= n ; i ++)
    {
        plants[0] += plants[i] * spears[i-1];
    }
    for(int i = n ; i > 0 ; i --)
    {
        plants[i] = plants[i - 1];
    }


}*/

int half_long_div(string sa , long long b)
{
    long long s = 0 , ost = 0;
    long long a[nmax + 2] = {0};
    string_to_int(sa,a);
    int res[nmax + 2] = {0};
    for(int i = nmax - a[0] + 1 ; i <= nmax ; i ++)
    {
        s = ost * 10 + a[i];
        ost = s % b;
    }
    return ost;
}

int main()
{
    freopen("cucumbers.in" , "r" , stdin);
    freopen("cucumbers.out" , "w" , stdout);
    long long m, n, spears[10] = {0} , boxes[10];
    string plants[10];
    plants[1] = "1";
    cin >> m >> n;
    mas_in(n , spears);
    mas_in(n , boxes);
    for( long long i = 0 ; i < m - 1 ; i ++)
    {
        growth( plants , spears , n );
    }
    for(int i = 1 ; i <= n - 1 ; i ++)
        cout << half_long_div(plants[i], boxes[i - 1]) << " ";
    cout << half_long_div(plants[n], boxes[n - 1]) << "\n";

    /*int m ,s = 1 , n , spears[10] = {0} , plants [100] = {0};
    plants[1] = 1;
    cin >> m;
    mas_in(n , spears);
    for( int i = 0 ; i < m - 1 ; i ++)
    {
        growth( plants , spears , n );
    }
    for(int i = 1 ; i <= n ; i ++)
        cout << plants[i] << " ";
    */
    return 0;
}
