/* GCC */

#include <bits/stdc++.h>
using namespace std;

struct point{
    int x, y;
};

double operator- (point a, point b)
{
    return {hypot ((a.x - b.x), (a.y - b.y))};
}

double geron (point a, point b, point c)
{
    double p = ((b-a) + (b-c) + (c-a))/ 2;
    return sqrt(p*(p - (b-a)) * (p - (b - c)) * (p - (c - a)));
}

double rounder (double a)
{
    if (a == floor (a) + 0.5) return floor(a) + 0.5;
    if (a == floor (a)) return floor (a);
    if (a - floor (a) > a - (floor (a) + 0.5)) return floor (a);
    return floor (a) + 0.5;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
	freopen ("triangle.in", "r", stdin);
	freopen ("triangle.out", "w", stdout);

	int n;
	cin >> n;
	point p[n];
	for (int i = 0; i < n; i++)
	{
		cin >> p[i].x >> p[i].y;
	}
	double max = geron (p[0], p[1], p[2]);
	for (int i = 0; i < n; i ++)
    {
        for (int j = 0; j < n; j ++)
        {
            for (int z = 0; z < n; z ++)
            {
                if (geron(p[i], p[j], p[z]) > max && i != j && i !=z && z != j) max = geron(p[i], p[j], p[z]);
            }
        }
    }

	cout << rounder (max);

	cout << "\n";
}
