/* GCC */

#include <iostream>
#include <vector>
#include <cstdio>
#include <math.h>
#define point pair<int,int>
#define x first
#define y second

using namespace std;

float dist(point a, point b) {
    float f = a.x - b.x;
    float s = a.y - b.y;
    return sqrt(f*f + s*s);
}

float area(point A, point B, point C) {
    float a = dist(B,C);
    float b = dist(A,C);
    float c = dist(A,B);
    float p = (a + b + c) / 2;
    return sqrt(p*(p-a)*(p-b)*(p-c));
}

int main() {
    freopen("triangle.in", "r", stdin);
    freopen("triangle.out", "w", stdout);

    int n = 0;
    cin >> n;
    vector<pair<int,int> > v(n, make_pair(0,0));
    for(int i = 0; i < n; i++) {
        int a = 0, b = 0;
        cin >> a >> b;
        v[i] = make_pair(a,b);
    }

    float mx = -1;
    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
            for(int k = j + 1; k < n; k++)
                mx = max(mx, area(v[i],v[j],v[k]));

    cout << mx << endl;

    return 0;
}
