/* GCC */
#include <iomanip>
#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

int tri[2000][2] ={0};
long leng[2000]={0};

double  length (int a[2], int b[2])
{
    double length;
    length = sqrt(((b[0]-a[0])*(b[0]-a[0])) +((b[1]-a[1])*(b[1]-a[1])));
    return length;
}

bool degrees90(double
                lenA, double lenB, double lenC)
{
    if((lenA*lenA)+(lenB*lenB)==lenC*lenC) return  true;
    if(lenC*lenC+lenB*lenB==lenA*lenA) return  true;
    if(lenA*lenA+lenC*lenC==lenB*lenB) return  true;
    return false;
}

double S(double lenA, double lenB, double lenC)
{
    double S;
    double p=(lenA+lenB+lenC)/2;
    S=sqrt(p*(p-lenA)*(p-lenB)*(p-lenC));
    return S;
}

int main()
{
    freopen("triangle.in", "r", stdin);
    freopen("triangle.out", "w", stdout);
    int n;
    double s;
    cin>>n;
    for(int i=0;i<n;i++)
        cin>>tri[i][0]>>tri[i][1];
    for(int i=0;i<n;i++)
        for(int k=i;k<n;k++)
        {
            leng[k]=length(tri[k], tri[k+1]);
        }
    sort(leng, leng+n);
        if (degrees90(leng[n-1], leng[n-2], leng[n-3])==true)
        {
            s=(leng[n-3]*leng[n-2])/2;
            cout<<s<<endl;
        }
        else
        {
            s=S(leng[n-3], leng[n-2], leng[n-3]);
            cout<<fixed<<setprecision(1)<<s<<endl;
        }
    return 0;
}
