/* GCC */
#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define point pair<int,int>
#define x first
#define y second

int s(point a,point b)
{
    return a.x*b.y-b.x*a.y;
}

int s(point o,point a,point b)
{
    a.x-=o.x;
    a.y-=o.y;
    b.x-=o.x;
    b.y-=o.y;
    return s(a,b);
}

const int N=2010;

point p[N];

signed main()
{
    #define name "triangle"
    freopen(name".in","r",stdin);
    freopen(name".out","w",stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>>n;
    for(int i=0;i<n;i++)
        cin>>p[i].x>>p[i].y;
    sort(p,p+n);
    point l=p[0],r=p[n-1];
    vector<point> res;
    for(int i=0;i<n;i++)
        if(s(p[i],l,r)>=0)
        {
            while(res.size()>=2)
                if(s(res.back(),res[res.size()-2],p[i])<0)
                    res.pop_back();
                else
                    break;
            res.push_back(p[i]);
        }
    res.push_back(r);
    for(int i=n-1;i>=0;i--)
        if(s(p[i],l,r)<=0)
        {
            while(res.size()>=2)
                if(s(res.back(),res[res.size()-2],p[i])<0)
                    res.pop_back();
                else
                    break;
            res.push_back(p[i]);
        }
    int k=res.size(),ans=0;
    for(int i=0;i<n;i++)
    {
        for(int j=i+1,k=j+1;j<n;j++)
        {
            int a=abs(s(p[i],p[j],p[k]));
            ans=max(ans,a);
            while(k<n-1)
            {
                int b=abs(s(p[i],p[j],p[k+1]));
                if(b<a)
                    break;
                k++;
                a=b;
                ans=max(ans,a);
            }
        }
    }
    cout<<(ans>>1);
    if(ans&1)
        cout<<".5";
    cout<<"\n";
}
