/* GCC */
#include <bits/stdc++.h>

#define pb push_back

#define mp make_pair

using namespace std;

const int inf = 10e8;
vector<vector<int> > g;

int n, m, k;

vector<int> dijkstra(int s){
    vector<bool> used(n);
    vector<int> d(n,inf);
    d[s] = 0;
    for(int i = 0; i < n; i++)
    {
        int v = -1;
        for(int j = 0; j < n; j++)
            if(!used[j] && (d[j] < d[v] || v == -1))
                v = j;
        if(d[v] == inf) break;
        used[v] = true;
        for(unsigned int j = 0; j < g[v].size(); j++)
        {
            int to = g[v][j];
            int len = 1;
            if(d[v] + len < d[to])
                d[to] = d[v] + len;
        }
    }
    return d;
}



int main()
{
    freopen("hiking.in","r",stdin);
    freopen("hiking.out","w",stdout);
    vector<int> dots, ans, d;
    cin >> n >> m >> k;
    int dot1,dot2;
    for(int i = 0; i < m; i++){
        cin >> dot1 >> dot2;
        g[dot1].pb(dot2);
        g[dot2].pb(dot1);
    }
    for(int i = 0; i < k; i++){
        cin >> dot1;
        dots.pb(dot1);
    }
    for(int i = 0; i < k; i++)
    {
        d = dijkstra(dots[i]);
        for(int j = 0; j < k; j++)
            if(j != i)
                ans.pb(d[j]);
    }
    sort(ans.begin(), ans.end());
    cout << ans[0];



    return 0;
}
