/* GCC */
#include <iostream>
#include <fstream>
using namespace std;
long long NOD(long long a, long long b)
{
    while(a!=b)
    {
        if(a>b)
            a-=b;
        else b -= a;
    }
    return a;
}
long long NOK(long long a, long long b)
{
    return a*b / NOD(a,b);
}
int main()
{
    ifstream fin("cucumbers.in");
    ofstream fout("cucumbers.out");
    unsigned long long m, x;
    int n;
    fin>>m>>n;
    if(m>1000)
        m = 1000 + m%1000;
    unsigned long long cucumbers[n+1];
    for(register int i = 0; i < n+1; i++)
        cucumbers[i] = 0;
    cucumbers[0] = 1;
    long long Aj[n], Bj[n];
    for(register int i = 0; i < n; i++)
        fin>>Aj[i];
    for(register int i = 0; i < n; i++)
        fin>>Bj[i];
    if(n<2)
        x = Bj[0];
    else
    {
        x = NOK(Bj[0], Bj[1]);
        for(int i = 2; i < n; i++)
        {
            x = NOK(x, Bj[i]);
        }
    }
    for(register long long i = 0; i < m; i++)
    {
        for(int j = n; j >=0; j--)
        {
            if(j == n)
                cucumbers[j] = 0;
            else
            {
                cucumbers[j+1] = cucumbers[j];
                cucumbers[j] = 0;
            }
        }
        for(int j = 1; j < n+1; j++)
        {
            cucumbers[j] %= x;
            cucumbers[0] += cucumbers[j] * Aj[j-1];
        }
    }
    for(int i = 1; i < n+1; i++)
    {
        fout<<cucumbers[i] % Bj[i-1]<<" ";
    }
    fout<<endl;
    return 0;
}
