/* GCC */
#include <bits/stdc++.h>
#define int unsigned long long
#define fi first
#define se second
#define pb push_back

using namespace std;

void out(vector<vector<int> > c)
{
    for (int j=0; j<c[0].size(); j++, cout<<"\n")
    for (int i=0; i<c.size(); i++)
        cout<<c[i][j]<<" ";
    cout<<"\n";
}

int n, m;
int l=1;
vector<vector<int> > mul(vector<vector<int> > a, vector<vector<int> > b)
{
    vector<vector<int> > c;
    c.resize(n);
    for (int i=0; i<n; i++)
        c[i].resize(n);
    for (int i=0; i<n; i++)
        for (int j=0; j<n; j++)
            for (int k=0; k<n; k++)
    {
        c[i][j]+=a[i][k]*b[k][j];
        c[i][j]%=l;
    }
    return c;
}

vector<vector<int> > ppow(vector<vector<int> > a, int b)
{
    if (b==1)
        return a;
    vector<vector<int> > c=ppow(a, b/2);
    c=mul(c, c);
    if (b%2==0)
        return c;
    return mul(c, a);
}

int a[100];
int b[100];
int t[100500];
int ans[100];

int gcd(int a, int b)
{
    while ((a>0) and (b>0))
        if (a>b)
            a%=b;
        else
            b%=a;
    return max(a, b);
}

int lcm(int a, int b)
{
    return (a/gcd(a, b))*b;
}

main()
{
    freopen("cucumbers.in", "r", stdin);
    freopen("cucumbers.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>m>>n;

    for (int i=1; i<=n; i++)
        cin>>a[i];
    for (int i=1; i<=n; i++)
        cin>>b[i], l=lcm(l, b[i]);
    for (int i=1; i<=n; i++)
        a[i]%=l;

    if (m==1)
    {
        cout<<1%b[1];
        for (int i=1; i<n; i++)
            cout<<" 0";
        cout<<"\n";
        return 0;
    }

    vector<vector<int> > c;
    c.resize(n);
    for (int i=0; i<n; i++)
        c[i].resize(n);
    for (int i=1; i<n; i++)
        c[i][i-1]=1;
    for (int i=0; i<n; i++)
        c[i][n-1]=a[n-i];

    c=ppow(c, m-1);
    for (int i=n-1; i>=0; i--)
    {
        cout<<c[n-1][i]%b[n-i];
        if (i!=0)
            cout<<" ";
        else
            break;
    }

    return 0;
}
