/* GCC */
#include <bits/stdc++.h>
using namespace std;

//#define int long long
const int MAXN = 2010, INF = 10000000;

vector<int> g[MAXN];
int dist[MAXN];
int p[MAXN];
int n, m, k;
queue<int> q;

int bfs(int fg)
{
    for(int i = 0; i<n; i++)
        dist[i]=INF;
    dist[fg]=0;
    q.push(fg);
    int v;
    while(!q.empty())
    {
        v = q.front();
        q.pop();
        for(int i = 0; i<g[v].size(); i++)
        {
            int to = g[v][i];
            if(dist[to]>=INF)
            {
                q.push(to);
                dist[to]=dist[v]+1;

            }
        }
    }
    int ans = INF;
    for(int i = 0; i<k; i++)
    {
        if(p[i]!=fg)
        ans = min(ans, dist[p[i]]);
    }
    return ans;
}
int main()
{
    ifstream cin("hiking.in");
    ofstream cout("hiking.out");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> k;
    int u, v, i;
    for(i = 0; i<m; i++)
    {
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for(i = 0; i<k; i++)
    {
        cin >> p[i];
        p[i]--;
    }
    int ans = INF;
    for(i = 0; i<k; i++)
        ans = min(ans, bfs(p[i]));
    cout << ans << '\n';
    return 0;
}
