/* GCC */
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define pii pair<int,int>

#define MAXN 2100
#define INF 2000000000
#define MOD 1000000007

int n;
pii A[MAXN];

double abs(double a)
{
    if (a < 0) return (-1)*a;
    return a;
}

double Space(int x1, int y1, int x2, int y2)
{
    double S;
    S = x1*y2 - x2*y1;
    S /= 2;
    return S;
}

int main(void)
{
    freopen("triangle.in", "r", stdin);
    freopen("triangle.out", "w", stdout);

    cin >> n;
    int x, y;
    for (int i=0; i<n; i++){
        cin >> x >> y;
        A[i] = make_pair(x, y);
    }

    pii p1, p2, p3;
    double S, Smax=0;
    for (int i=0; i<n; i++){
        for (int j=0; j<n; j++){
            for (int l=0; l<n; l++){
                if ((i == j) || (i == l) || (j == l)) continue;
                p1 = A[i]; p2 = A[j]; p3 = A[l];
                S = Space(p1.first-p3.first, p1.second-p3.second, p2.first-p3.first, p2.second-p3.second);
                S = abs(S);
                Smax = max(Smax, S);
            }
        }
    }

//    double Smax = 1.5;
    cout << Smax << "\n";

    return 0;
}

