/* GCC */
#include <bits/stdc++.h>
#define pb push_back
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef pair<ll,ll> pll;
typedef vector <ll> vll;

vector < vll > g;
vector < bool > color, u, used;
vll d;
ll _min = 1000000000, n;

ll bfs(ll st)
{
    used.clear();
    d.clear();
    queue<ll> q;
    used.resize(n,0); used[st] = 1;
    d.resize(n,0);
    q.push(st);
    while(!q.empty())
    {
        ll v = q.front();
        q.pop();
        for(ll i = 0; i<g[v].size(); i++)
        {
            ll ver = g[v][i];
            if(!used[ver])
            {
                used[ver] = 1;
                d[ver] = d[v]+1;
                q.push(ver);
                if(color[ver]==1)
                {
                    _min = min(d[ver],_min);
                    if(_min==1) return _min;
                    if(u[ver]!=1) { u[ver] = 1; bfs(ver); }
                    return _min;
                }
            }
        }
    }
}

int main()
{
    freopen("hiking.in","r",stdin);
    freopen("hiking.out","w",stdout);
    ll m, k;
    cin >> n >> m >> k;
    g.resize(n);
    ll p, q;
    for(ll i = 0; i<m; i++)
    {
        cin >> p >> q;
        p--; q--;
        g[p].pb(q);
        g[q].pb(p);
    }
    color.resize(n,0);
    for(ll i = 0; i<k; i++)
    {
        cin >> p;
        p--;
        color[p] = 1;
    }
    u.resize(n,0);
    ll _m = 1000000000;
    for(ll i = 0; i<n; i++)
    {
        if(color[i]==1 && !u[i])
        {
            u[i] = 1; ll mp = bfs(i);
            if(mp<_m) _m = mp;
            if(_m==1) break;
        }
    }
    cout << _m << '\n';
    fclose(stdin);
    fclose(stdout);
}

