import java.io.*;
import java.util.ArrayList;
import java.util.Scanner;
public class hiking 
{
	public static void main(String[] args) throws Exception
	{
		FileReader fr1=new FileReader("hiking.in");
		Scanner scan1=new Scanner(fr1);
		
		int n=0;
		int m=0;
		int k=0;
		
		if(scan1.hasNextInt())
		{
			n=scan1.nextInt();
		}
		if(scan1.hasNextInt())
		{
			m=scan1.nextInt();
		}
		if(scan1.hasNextInt())
		{
			k=scan1.nextInt();
		}
		
		int[] data=new int[2*m+k];
		int t=0;
		while(scan1.hasNextInt())
		{
			data[t]=scan1.nextInt();
			t++;
		}
		
		fr1.close();
		scan1.close();
		
		////////////////////////////////////////////
		
		int[][] roads=new int[2][m];
		for(int i=0;i<2*m;i+=2)
		{
			roads[0][i/2]=data[i];
			roads[1][i/2]=data[i+1];
		}
		
		ArrayList<ArrayList<Integer>> fields=new ArrayList<ArrayList<Integer>>();
		for(int i=0;i<n;i++)
		{
			fields.add(new ArrayList<Integer>());
		}
		
		for(int a=0;a<n;a++)
		{
			for(int i=0;i<m;i++)
			{
				if(roads[0][i]==a+1)
				{
					fields.get(a).add(roads[1][i]);
				}
				else if(roads[1][i]==a+1)
				{
					fields.get(a).add(roads[0][i]);
				}
			}
		}
		
		int[] bus=new int[k];
		for(int i=2*m;i<2*m+k;i++)
		{
			bus[i-2*m]=data[i];
		}
		
		
		////////////////////////////////////////////////////////////////
		
		int result=1000000;
		ArrayList<Integer> info=walking(-1,-1,new ArrayList<Integer>(),fields,bus);
		for(int i=0;i<info.size();i++)
		{
			int d=info.get(i);
			if(result>d)
			{
				result=d;
			}
		}
		
		FileWriter fw2=new FileWriter("hiking.out");
		fw2.write(result+"\r\n");
		fw2.close();
	}
	
	public static ArrayList<Integer> walking(int currentField,int distance,ArrayList<Integer> visited,ArrayList<ArrayList<Integer>> fields,int[] bus)
	{
		ArrayList<Integer> res=new ArrayList<Integer>();
		if(currentField<0)
		{
			for(int i=0;i<bus.length;i++)
			{
				ArrayList<Integer> last=walking(bus[i],distance,visited,fields,bus);
				for(int a=0;a<last.size();a++)
				{
					res.add(last.get(a));
				}
			}
			return res;
		}
		
		distance++;
		visited.add(currentField);
		
		if(distance>0)
		{
			for(int i=0;i<bus.length;i++)
			{
				if(currentField==bus[i])
				{
					res.add(distance);
					return res;
				}
			}
		}
		/////////////////////
		for(int i=0;i<fields.get(currentField-1).size();i++)
		{
			boolean wasHere=false;
			for(int a=0;a<visited.size();a++)
			{
				if(fields.get(currentField-1).get(i)==visited.get(a))
				{
					wasHere=true;
					break;
				}
			}
			if(!wasHere)
			{
				ArrayList<Integer> last=walking(fields.get(currentField-1).get(i),distance,visited,fields,bus);
				for(int a=0;a<last.size();a++)
				{
					res.add(last.get(a));
				}
			}
		}
		
		return res;
	}
	
}
