/* GCC */

#include <cstdio>
#include <algorithm>

#define MAX 10

using namespace std;

int m, n;
int a[MAX - 1], b[MAX - 1];
int progress[MAX];

void init(){
    freopen("cucumbers.in", "r", stdin);
    freopen("cucumbers.out", "w", stdout);
    scanf("%d %d", &m, &n);
    for(int i = 0; i < n; i++){
        scanf("%d", &a[i]);
    }
    for(int i = 0; i < n; i++){
        scanf("%d", &b[i]);
    }
}

int main()
{
    init();
    fill(progress, progress + MAX, 0);
    progress[0] = 1;
    for(int i = 0; i < m; i++){
        for(int i = n; i > 0; i--){
            progress[i] = progress[i - 1];
        }
        progress[0] = 0;
        for(int i = n; i > 0; i--){
            progress[0] += progress[i] * a[i - 1];
        }
    }
    printf("%d", progress[1] % b[0]);
    for(int i = 2; i <= n; i++){
        printf(" %d", progress[i] % b[i - 1]);
    }
    printf("\n");
    return 0;
}
