/* GCC */
#include<iostream>
#include<vector>
#include<cmath>
#include<cstdio>

using namespace std;

int main()
{
    	freopen("triangle.in", "r", stdin);
	freopen("triangle.out", "w", stdout);


	int n;
    cin >> n;
    vector <pair<int, int>> v;
    int maxr = -20001, maxl = 20001, maxu = -20001, maxd = 20001;
    for (int i = 0; i < n; i++)
    {
        int a, b; cin >> a >> b;
        v.push_back(make_pair(a, b));
        if(a > maxr) maxr = a;
        if(a < maxl) maxl = a;
        if(b > maxu) maxu = b;
        if(b < maxd) maxd = b;
    }

    vector <pair<int, int>> m;
    for (int i = 0; i < n; i++)
    {
        if (v[i].first == maxr || v[i].first == maxl) m.push_back(v[i]);
        if (v[i].second == maxu || v[i].second == maxd) m.push_back(v[i]);
    }

    double smax = 0.0;
    for (int i = 0; i < m.size(); i++)
        for (int j = 0; j < n; j++)
            for (int k = 0; k < n; k++)
            {
                int fi = m[i].first; int si = m[i].second; int fj = v[j].first; int sj = v[j].second; int fk = v[k].first; int sk = v[k].second;
                double a = sqrt((fi - fj)*(fi - fj) + (si - sj)*(si - sj));
                double b = sqrt((fi - fk)*(fi - fk) + (si - sk)*(si - sk));
                double c = sqrt((fj - fk)*(fj - fk) + (sj - sk)*(sj - sk));
                double p = (a + b + c)/2;
                double S = sqrt(p*(p - a)*(p - b)*(p - c));
                if (S > smax) smax = S;
            }

    cout << smax << endl;
}
