/* GCC */

#include <bits/stdc++.h>

using namespace std;

double length(int x1, int y1, int x2, int y2){
    int xL = x1-x2;
    int yL = y1-y2;
    if(xL < 0) xL*=-1;
    if(yL < 0) yL*=-1;
    return sqrt(xL*xL+yL*yL);
}

double rect(int x1, int y1, int x2, int y2, int x3, int y3){
    double l1 = length(x1,y1,x2,y2);
    double l2 = length(x2,y2,x3,y3);
    double l3 = length(x3,y3,x1,y1);
    double p = (l1+l2+l3)/2;
    double res = sqrt(p*(p-l1)*(p-l2)*(p-l3));
    if(res < 0) return 0;
    return res;
}

int main()
{
    ifstream ifs;
    ofstream ofs;
    ofs.open("triangle.out");
    ifs.open("triangle.in");

    int n;
    ifs >> n;
    int x[2000];
    int y[2000];
    for(int i = 0;i<n;i++) ifs >> x[i] >> y[i];

    double maxRect = 0;

    for(int i = 0;i<n-2;i++){
        for(int j = i+1;j<n-1;j++){
            for(int k = j+1;k<n;k++){
                double rect1 = rect(x[i], y[i], x[j], y[j], x[k], y[k]);
                if(rect1 > maxRect) maxRect = rect1;
            }
        }
    }

    ofs << maxRect << endl;

    ifs.close();
    ofs.close();
}
