/* GCC */
#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

struct node {
    vector<int> nodes;
    bool stop = false;
    int color = -1;
    int j = -1;
};

node* d;
int n, k;
int* ks;

int dikstra() {
    vector<int> nds;
    for (int i = 0;i < k;i++) {
        nds.push_back(ks[i]);
        d[ks[i]].color = i;
    }

    int j = 1;
    while (j < n) {
        vector<int> new_nds;
        for (int l = 0;l < nds.size();l++) {
            for (int i = 0;i < d[nds[l]].nodes.size();i++) {
                int color = d[d[nds[l]].nodes[i]].color;
                if (color == -1) {
                    new_nds.push_back(d[nds[l]].nodes[i]);
                    d[d[nds[l]].nodes[i]].color = d[nds[l]].color;
                    d[d[nds[l]].nodes[i]].j = j;
                } else if (color != d[nds[l]].color) {
                    if (d[d[nds[l]].nodes[i]].j == j) {
                        return j * 2;
                    }
                    else {
                        return j * 2 - 1;
                    }
                }
            }
        }
        nds = new_nds;
        j++;
    }
    return -1;
}

int main() {
    freopen("hiking.in", "r", stdin);
    freopen("hiking.out", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    std::ios_base::sync_with_stdio(false);
    int m;
    cin >> n >> m >> k;
    d = new node[n];
    for (int i = 0;i < m;i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        d[a].nodes.push_back(b);
        d[b].nodes.push_back(a);
    }
    ks = new int[k];
    for (int i = 0;i < k;i++) {
        cin >> ks[i];
        ks[i]--;
    }
    cout << dikstra() << endl;
    fclose(stdout);
    fclose(stdin);
    return 0;
}
