/* GCC */
#pragma GCC optimize("O3")
#include <bits/stdc++.h>

#define int unsigned long long

using namespace std;

int lcm(int a,int b)
{
    return a/__gcd(a,b)*b;
}

int n,mod;

typedef vector<int> vi;
typedef vector<vi> vvi;

vvi mult(vvi x,vvi y)
{
    vvi res(n,vi(n));
    for(int i=0;i<n;i++)
        for(int j=0;j<n;j++)
            for(int k=0;k<n;k++)
                res[i][k]+=x[i][j]*y[j][k]%mod;
    return res;
}

vvi ppow(vvi x,int y)
{
    vvi res=vvi(n,vi(n));
    for(int i=0;i<n;i++)
        res[i][i]=1;
    while(y)
    {
        if(y&1)
            res=mult(res,x);
        x=mult(x,x);
        y>>=1;
    }
    return res;
}

signed main()
{
    #define name "cucumbers"
    freopen(name".in","r",stdin);
    freopen(name".out","w",stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m;
    cin>>m>>n;
    int a[n],b[n];
    for(int i=0;i<n;i++)
        cin>>a[i];
    for(int i=0;i<n;i++)
        cin>>b[i];
    mod=1;
    for(int i=0;i<n;i++)
        mod=lcm(mod,b[i]);
    vvi x(n,vi(n));
    for(int i=0;i<n-1;i++)
        x[i][i+1]=1;
    for(int i=0;i<n;i++)
        x[i][0]=a[i];
    vvi res=ppow(x,m-1);
    for(int i=0;i<n;i++)
        cout<<res[0][i]%b[i]<<(i==n-1?"\n":" ");
}
