/* GCC */

#include <fstream>

using namespace std;

int main()
{
    //check_types
    ifstream file_r;
    file_r.open("cucumbers.in");
    int left_for = 0;
    file_r >> left_for;
    int age = 0;
    file_r >> age;
    int fertility[age];
    for(int i = 0; i < age; i++)
    {
        file_r >> fertility[i];
    }
    int containers[age];
    for(int i = 0; i < age; i++)
    {
        file_r >> containers[i];
    }
    file_r.close();

    int flower_system[age+1] = {1, 0, 0};

    for(int i = 0; i < left_for; i++)
    {
        int spores = 0;
        for(int j = age; j > 0; j--)
        {
            flower_system[j] = flower_system[j-1];
            spores += flower_system[j] * fertility[j-1];
        }
        flower_system[0] = spores;
    }

    for(int i = 0; i < age; i++)
    {
        containers[i] = flower_system[i+1] % containers[i];
    }

    ofstream file_w;
    file_w.open("cucumbers.out");
    for(int i = 0; i < age - 1; i++)
    {
        file_w << containers[i] << " ";
    }
    file_w << containers[age-1] << endl;
    file_w.close();
    return 0;
}
