/* GCC */

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector < vector < ll > > g;
vector < ll > d, a;
vector < bool > used;

void bfs(ll s)
{
    queue < ll > q;
    q.push(s);
    used [s] = true;
    while (!q.empty())
    {
        ll v = q.front();
        q.pop();
        for (ll i = 0; i < g [v].size(); ++i)
        {
            ll to = g [v][i];
            if (!used [to])
            {
                d [to] = d [v] + 1;
                used [to] = true;
                q.push(to);
            }
        }
    }
}

int main()
{
    freopen("hiking.in", "r", stdin);
    freopen("hiking.out", "w", stdout);
    cin.tie(NULL);
    ll n, m, k, mi = LONG_LONG_MAX;
    cin >> n >> m >> k;
    g.resize(n);
    for (ll i = 0; i < m; ++i)
    {
        ll p, q;
        cin >> p >> q;
        --p;
        --q;
        g [q].push_back(p);
        g [p].push_back(q);
    }
    for (ll i = 0; i < k; ++i)
    {
        ll p;
        cin >> p;
        --p;
        a.push_back(p);
    }
    for (ll i = 0; i < k - 1; ++i)
    {
        ll s = a [i];
        d.clear();
        used.clear();
        d.resize(n);
        used.resize(n);
        bfs(s);
        for (ll j = i + 1; j < k; ++j)
        {
            if (d [a [j]] < mi) mi = d [a [j]];
        }
    }
    cout << mi << '\n';
}
