/* GCC */

#include <vector>
#include <map>
#include <iostream>
#include <iomanip>
#include <set>
#include <cmath>
#include <fstream>
#include <algorithm>

#define x first
#define y second
using namespace std;
typedef long long ll;
typedef pair<double, double> pdd;
pdd operator-(pdd a, pdd b){
    pdd c;
    c.first = a.first - b.first;
    c.second =  a.second - b.second;
    return c;
}
const int maxn = 10;
const ll  maxnum = 5e4 + 1;
pdd arr[maxn];
vector <pdd> wrap;
double area(pdd c, pdd a, pdd b){
    a= a - c;
    b = b - c;
    return (a.x * b.y - b.x * a.y) / 2.;
}
bool comp(pdd a, pdd b){
    return a.x < b.x;
}
int n;
void makeWrap(){
    wrap.push_back(arr[1]);
    int cnt = 0;
    for(int i = 2; i < n; ++i){
        while(wrap.size() >= 2 && area(wrap[wrap.size() - 2], wrap[wrap.size() - 1], arr[i]) >= 0)
            wrap.pop_back();
        if(wrap.size() < 2 || area(wrap[wrap.size() - 2], wrap[wrap.size() - 1], arr[i]) < 0)
            wrap.push_back(arr[i]);
    }
    vector< pdd> wrap_reverse;
    wrap_reverse.push_back(wrap[0]);
    wrap_reverse.push_back(arr[1]);
    for(int i = 2; i < n; ++i){
        while(wrap_reverse.size() >= 2 && area(wrap_reverse[wrap_reverse.size() - 2], wrap_reverse[wrap_reverse.size() - 1], arr[i]) <= 0)
            wrap_reverse.pop_back();
        if(wrap_reverse.size() < 2 || area(wrap_reverse[wrap_reverse.size() - 2], wrap_reverse[wrap_reverse.size() - 1], arr[i]) > 0){
            wrap_reverse.push_back(arr[i]);
            if(arr[i] == wrap.back())
                break;
        }
    }
    for(int i = wrap_reverse.size() - 2; i >0; --i)
        wrap.push_back(wrap_reverse[i]);
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    freopen("triangle.in", "r", stdin);
    freopen("triangle.out", "w", stdout);
    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> arr[i].x >> arr[i].y;
    }
    sort(arr, arr + n, comp);
    wrap.push_back(arr[0]);
    makeWrap();
    double maxi = 0;
    if(wrap.size() > 2)
        for(int i = 0; i < wrap.size(); ++i)
            for(int j = 0; j < wrap.size(); ++j)
                for(int k = 0; k < wrap.size(); ++k){
                    maxi = max(maxi, abs(area(wrap[i], wrap[j], wrap[k])));
        }
    int t = maxi;
    if(maxi ==  double(t))
        cout << t << '\n';
    else cout << fixed << setprecision(1) << maxi << '\n';
    return 0;
}
